//
//  imageErweimaViewController.m
//  原生扫描生成demo
//
//  Created by mac on 16/11/17.
//  Copyright © 2016年 TXZhongJiaowang. All rights reserved.
//

#import "imageErweimaViewController.h"

@interface imageErweimaViewController ()
@property (nonatomic,strong)UIImageView *imageV;
@end

@implementation imageErweimaViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    // Do any additional setup after loading the view.
    self.view.backgroundColor = [UIColor whiteColor];
    self.automaticallyAdjustsScrollViewInsets = NO;
    
    UIImage *image = [self creatImageER];
    
    UIImage *imageImage = [self addSmallImageForQRImage:image];
    
    UIImage *endImage = [self changeColorForQRImage:imageImage backColor:[UIColor redColor] frontColor:[UIColor yellowColor]];
    
    
    [self.view addSubview:self.imageV];
    self.imageV.image = endImage;
}
- (UIImage *)creatImageER{
#pragma mark * 生成二维码
    //制定规格
    static NSString *string = @"http://www.c-c.com";
    CGSize size = CGSizeMake(300, 300);
    
    NSData *stringData = [string dataUsingEncoding:NSUTF8StringEncoding];
    //创建一个过滤器类
    CIFilter *qrFilter = [CIFilter filterWithName:@"CIQRCodeGenerator"];
    [qrFilter setValue:stringData forKey:@"inputMessage"];
    [qrFilter setValue:@"M" forKey:@"inputCorrectionLevel"];
    
    NSLog(@"qrFilter --> %@",qrFilter);
    CIImage *qrImage = qrFilter.outputImage;
    //放大并绘制二维码 (上面生成的二维码很小,需要放大)
    CIContext *CIcontext = [CIContext contextWithOptions:nil];
    NSLog(@"qrImage --> %@",qrImage);
    //调用上下文和提供的CIImage 生成 CGImageRef
    CGImageRef cgImage = [CIcontext createCGImage:qrImage fromRect:qrImage.extent];
    //新创建的上下文大小
    UIGraphicsBeginImageContext(size);
    CGContextRef context = UIGraphicsGetCurrentContext();
    CGContextSetInterpolationQuality(context, kCGInterpolationNone);
    //翻转图片,否则生成的QRCode是上下颠倒的
    CGContextScaleCTM(context, 1.0, -1.0);
    CGContextDrawImage(context, CGContextGetClipBoundingBox(context), cgImage);
    UIImage *codeImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    CGImageRelease(cgImage);
    
    return codeImage;
}

- (UIImageView *)imageV{
    if (!_imageV) {
        self.imageV = [[UIImageView alloc]initWithFrame:CGRectMake(0, 0, 300, 300)];
        self.imageV.center = self.view.center;
    }
    return _imageV;
}
/** 为二维码改变颜色 */
- (UIImage *)changeColorForQRImage:(UIImage *)image backColor:(UIColor *)backColor frontColor:(UIColor *)frontColor
{
    CIFilter *colorFilter = [CIFilter filterWithName:@"CIFalseColor" keysAndValues:
                             @"inputImage",[CIImage imageWithCGImage:image.CGImage],
                             @"inputColor0",[CIColor colorWithCGColor:frontColor.CGColor],
                             @"inputColor1",[CIColor colorWithCGColor:backColor.CGColor],
                             nil];
    
    return [UIImage imageWithCIImage:colorFilter.outputImage];
}

- (UIImage *)addSmallImageForQRImage:(UIImage *)qrImage{
    UIGraphicsBeginImageContext(qrImage.size);
    [qrImage drawInRect:CGRectMake(0, 0, qrImage.size.width, qrImage.size.height)];
    UIImage *image = [UIImage imageNamed:@"small"];
    
    CGFloat imageW = 50;
    CGFloat imageX = (qrImage.size.width - imageW) * 0.5;
    CGFloat imgaeY = (qrImage.size.height - imageW) * 0.5;
    
    [image drawInRect:CGRectMake(imageX, imgaeY, imageW, imageW)];
    
    UIImage *result = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    return result;
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

/*
#pragma mark - Navigation

// In a storyboard-based application, you will often want to do a little preparation before navigation
- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    // Get the new view controller using [segue destinationViewController].
    // Pass the selected object to the new view controller.
}
*/

@end
