//
//  txCreateERCImageView.m
//  原生扫描生成demo
//
//  Created by mac on 16/11/17.
//  Copyright © 2016年 TXZhongJiaowang. All rights reserved.
//

#import "txCreateERCImageView.h"

@implementation txCreateERCImageView

- (instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
        
    }
    return self;
}

- (UIImage *)createNormalERImageView{
#pragma mark * 生成二维码
    //制定规格
    NSString *string = self.erTitleString;
    CGSize size = CGSizeMake(self.frame.size.width, self.frame.size.height);
    
    NSData *stringData = [string dataUsingEncoding:NSUTF8StringEncoding];
    //创建一个过滤器类
    CIFilter *qrFilter = [CIFilter filterWithName:@"CIQRCodeGenerator"];
    [qrFilter setValue:stringData forKey:@"inputMessage"];
    [qrFilter setValue:@"M" forKey:@"inputCorrectionLevel"];
    
    NSLog(@"qrFilter --> %@",qrFilter);
    CIImage *qrImage = qrFilter.outputImage;
    //放大并绘制二维码 (上面生成的二维码很小,需要放大)
    CIContext *CIcontext = [CIContext contextWithOptions:nil];
    NSLog(@"qrImage --> %@",qrImage);
    //调用上下文和提供的CIImage 生成 CGImageRef
    CGImageRef cgImage = [CIcontext createCGImage:qrImage fromRect:qrImage.extent];
    //新创建的上下文大小
    UIGraphicsBeginImageContext(size);
    CGContextRef context = UIGraphicsGetCurrentContext();
    CGContextSetInterpolationQuality(context, kCGInterpolationNone);
    //翻转图片,否则生成的QRCode是上下颠倒的
    CGContextScaleCTM(context, 1.0, -1.0);
    CGContextDrawImage(context, CGContextGetClipBoundingBox(context), cgImage);
    UIImage *codeImage = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    CGImageRelease(cgImage);
    
    return codeImage;
}
- (UIImage *)createColorERImageView:(UIColor *)backColor frontColor:(UIColor *)frontColor{
    
    UIImage *image = [self createNormalERImageView];
    CIFilter *colorFilter = [CIFilter filterWithName:@"CIFalseColor" keysAndValues:
                             @"inputImage",[CIImage imageWithCGImage:image.CGImage],
                             @"inputColor0",[CIColor colorWithCGColor:frontColor.CGColor],
                             @"inputColor1",[CIColor colorWithCGColor:backColor.CGColor],
                             nil];
    
    return [UIImage imageWithCIImage:colorFilter.outputImage];
}
- (UIImage *)createNormalSmallImageERImageView{
    UIImage *image = [self createSmallImageERImageView:[self createNormalERImageView]];
    return image;
}

- (UIImage *)createColorSmallImageERImageView:(UIColor *)backColor frontColor:(UIColor *)frontColor{
    UIImage *qrImage = [self createColorERImageView:backColor frontColor:frontColor];
    UIImage *image = [self createSmallImageERImageView:qrImage];
    
    return image;
}

- (UIImage *)createSmallImageERImageView:(UIImage *)qrImage{
    UIGraphicsBeginImageContext(qrImage.size);
    [qrImage drawInRect:CGRectMake(0, 0, qrImage.size.width, qrImage.size.height)];
    UIImage *image = [UIImage imageNamed:self.erSmallImage];
    
    CGFloat imageW = 50;
    CGFloat imageX = (qrImage.size.width - imageW) * 0.5;
    CGFloat imgaeY = (qrImage.size.height - imageW) * 0.5;
    
    [image drawInRect:CGRectMake(imageX, imgaeY, imageW, imageW)];
    
    UIImage *result = UIGraphicsGetImageFromCurrentImageContext();
    UIGraphicsEndImageContext();
    
    return result;
}
@end
